<template>
  <div>
    <h2 id="page-heading" data-cy="PacienteHeading">
      <span v-text="$t('gatewayApp.pacientesPaciente.home.title')" id="paciente-heading">Pacientes</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesPaciente.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'PacienteCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-paciente"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesPaciente.home.createLabel')"> Create a new Paciente </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && pacientes && pacientes.length === 0">
      <span v-text="$t('gatewayApp.pacientesPaciente.home.notFound')">No pacientes found</span>
    </div>
    <div class="table-responsive" v-if="pacientes && pacientes.length > 0">
      <table class="table table-striped" aria-describedby="pacientes">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('nombre')">
              <span v-text="$t('gatewayApp.pacientesPaciente.nombre')">Nombre</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('tipoIdentificacion')">
              <span v-text="$t('gatewayApp.pacientesPaciente.tipoIdentificacion')">Tipo Identificacion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'tipoIdentificacion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('identificacion')">
              <span v-text="$t('gatewayApp.pacientesPaciente.identificacion')">Identificacion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'identificacion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('edad')">
              <span v-text="$t('gatewayApp.pacientesPaciente.edad')">Edad</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'edad'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('sexo')">
              <span v-text="$t('gatewayApp.pacientesPaciente.sexo')">Sexo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'sexo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('telefono')">
              <span v-text="$t('gatewayApp.pacientesPaciente.telefono')">Telefono</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'telefono'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('direccion')">
              <span v-text="$t('gatewayApp.pacientesPaciente.direccion')">Direccion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'direccion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('pesoKG')">
              <span v-text="$t('gatewayApp.pacientesPaciente.pesoKG')">Peso KG</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'pesoKG'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('estaturaCM')">
              <span v-text="$t('gatewayApp.pacientesPaciente.estaturaCM')">Estatura CM</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'estaturaCM'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('grupoEtnico')">
              <span v-text="$t('gatewayApp.pacientesPaciente.grupoEtnico')">Grupo Etnico</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'grupoEtnico'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('estratoSocioeconomico')">
              <span v-text="$t('gatewayApp.pacientesPaciente.estratoSocioeconomico')">Estrato Socioeconomico</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'estratoSocioeconomico'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('oximetriaReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.oximetriaReferencia')">Oximetria Referencia</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'oximetriaReferencia'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('ritmoCardiacoReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.ritmoCardiacoReferencia')">Ritmo Cardiaco Referencia</span>
              <jhi-sort-indicator
                :current-order="propOrder"
                :reverse="reverse"
                :field-name="'ritmoCardiacoReferencia'"
              ></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('presionSistolicaReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.presionSistolicaReferencia')">Presion Sistolica Referencia</span>
              <jhi-sort-indicator
                :current-order="propOrder"
                :reverse="reverse"
                :field-name="'presionSistolicaReferencia'"
              ></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('presionDistolicaReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.presionDistolicaReferencia')">Presion Distolica Referencia</span>
              <jhi-sort-indicator
                :current-order="propOrder"
                :reverse="reverse"
                :field-name="'presionDistolicaReferencia'"
              ></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('comentarios')">
              <span v-text="$t('gatewayApp.pacientesPaciente.comentarios')">Comentarios</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'comentarios'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('pasosReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.pasosReferencia')">Pasos Referencia</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'pasosReferencia'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('caloriasReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.caloriasReferencia')">Calorias Referencia</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'caloriasReferencia'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('metaReferencia')">
              <span v-text="$t('gatewayApp.pacientesPaciente.metaReferencia')">Meta Referencia</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'metaReferencia'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.pacientesPaciente.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('ciudad.ciudad')">
              <span v-text="$t('gatewayApp.pacientesPaciente.ciudad')">Ciudad</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'ciudad.ciudad'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('condicion.id')">
              <span v-text="$t('gatewayApp.pacientesPaciente.condicion')">Condicion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'condicion.id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('ips.nombre')">
              <span v-text="$t('gatewayApp.pacientesPaciente.ips')">Ips</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'ips.nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('tratamiento.descripcionTratamiento')">
              <span v-text="$t('gatewayApp.pacientesPaciente.tratamiento')">Tratamiento</span>
              <jhi-sort-indicator
                :current-order="propOrder"
                :reverse="reverse"
                :field-name="'tratamiento.descripcionTratamiento'"
              ></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('farmaceutica.nombre')">
              <span v-text="$t('gatewayApp.pacientesPaciente.farmaceutica')">Farmaceutica</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'farmaceutica.nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="paciente in pacientes" :key="paciente.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'PacienteView', params: { pacienteId: paciente.id } }">{{ paciente.id }}</router-link>
            </td>
            <td>{{ paciente.nombre }}</td>
            <td v-text="$t('gatewayApp.Identificaciont.' + paciente.tipoIdentificacion)">{{ paciente.tipoIdentificacion }}</td>
            <td>{{ paciente.identificacion }}</td>
            <td>{{ paciente.edad }}</td>
            <td v-text="$t('gatewayApp.Sexop.' + paciente.sexo)">{{ paciente.sexo }}</td>
            <td>{{ paciente.telefono }}</td>
            <td>{{ paciente.direccion }}</td>
            <td>{{ paciente.pesoKG }}</td>
            <td>{{ paciente.estaturaCM }}</td>
            <td v-text="$t('gatewayApp.Grupoetnicop.' + paciente.grupoEtnico)">{{ paciente.grupoEtnico }}</td>
            <td v-text="$t('gatewayApp.Estratop.' + paciente.estratoSocioeconomico)">{{ paciente.estratoSocioeconomico }}</td>
            <td>{{ paciente.oximetriaReferencia }}</td>
            <td>{{ paciente.ritmoCardiacoReferencia }}</td>
            <td>{{ paciente.presionSistolicaReferencia }}</td>
            <td>{{ paciente.presionDistolicaReferencia }}</td>
            <td>{{ paciente.comentarios }}</td>
            <td>{{ paciente.pasosReferencia }}</td>
            <td>{{ paciente.caloriasReferencia }}</td>
            <td>{{ paciente.metaReferencia }}</td>
            <td>
              {{ paciente.user ? paciente.user.login : '' }}
            </td>
            <td>
              <div v-if="paciente.ciudad">
                <router-link :to="{ name: 'CiudadView', params: { ciudadId: paciente.ciudad.id } }">{{
                  paciente.ciudad.ciudad
                }}</router-link>
              </div>
            </td>
            <td>
              <div v-if="paciente.condicion">
                <router-link :to="{ name: 'CondicionView', params: { condicionId: paciente.condicion.id } }">{{
                  paciente.condicion.id
                }}</router-link>
              </div>
            </td>
            <td>
              <div v-if="paciente.ips">
                <router-link :to="{ name: 'IPSView', params: { iPSId: paciente.ips.id } }">{{ paciente.ips.nombre }}</router-link>
              </div>
            </td>
            <td>
              <div v-if="paciente.tratamiento">
                <router-link :to="{ name: 'TratamientoView', params: { tratamientoId: paciente.tratamiento.id } }">{{
                  paciente.tratamiento.descripcionTratamiento
                }}</router-link>
              </div>
            </td>
            <td>
              <div v-if="paciente.farmaceutica">
                <router-link :to="{ name: 'FarmaceuticaView', params: { farmaceuticaId: paciente.farmaceutica.id } }">{{
                  paciente.farmaceutica.nombre
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'PacienteView', params: { pacienteId: paciente.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'PacienteEdit', params: { pacienteId: paciente.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(paciente)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.pacientesPaciente.delete.question" data-cy="pacienteDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-paciente-heading" v-text="$t('gatewayApp.pacientesPaciente.delete.question', { id: removeId })">
          Are you sure you want to delete this Paciente?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-paciente"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removePaciente()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./paciente.component.ts"></script>
